
(defun EARX:LIST-LAY (/ EARX_LIST EARX_DAT EARX_NAM)

  (setq EARX_LIST nil)                  ; Alte Datenliste lschen
  (setq EARX_DAT (tblnext "LAYER" T))   ;Solange noch Eintrge
  (while EARX_DAT
    (setq EARX_NAM (cdr (assoc 2 EARX_DAT)))
    (setq EARX_LIST (cons EARX_NAM EARX_LIST))
    (setq EARX_DAT (tblnext "LAYER"))
    ) ;_ end of while
  EARX_LIST
  ) ;_ end of defun

(defun DXF (A)
  (cdr (assoc A (entget ONE)))
  ) ;_ end of defun

(defun COMPLEX (one fuzz /)
  (while (not (wcmatch (DXF 0) "*END*"))
    (setq ONE  (entnext ONE)
          ELEM (append ELEM (list ONE))
          ) ;_ end of setq
    (CHECK one fuzz)
    ) ;_ end of while
  ) ;_ end of defun

(defun CORECT (A fuzz /)
  (cond
    ((= (type (cdr A)) 'list)
     (cons (car A)
           (mapcar '(lambda (X) (atof (rtos X 2 fuzz))) (cdr A))
           ) ;_ end of cons
     )
    ((equal (type (cdr A)) 'REAL)
     (cons (car A)
           (car
             (mapcar '(lambda (X) (atof (rtos X 2 8))) (list (cdr A)))
             ) ;_ end of car
           ) ;_ end of cons
     )
    (t A)
    ) ;_ end of cond
  ) ;_ end of defun

(defun CHECK (ONE fuzz /)
  (foreach X (entget ONE)
    (if (and
          (not (member (car X) '(-2 -1 2 5 6 48 60 100 102 330 360)))
          (/= (cdr (assoc 0 (entget ONE))) "DIMENSION")
          ) ;_ end of and
      (setq TEMP (cons (CORECT X fuzz) TEMP))
      ) ;_ end of if
    ) ;_ end of foreach
  ) ;_ end of defun


(defun revelem (el        /         tt        pktwertli ffwertli
                rdz       ugalist   ffwertlist          tmpfflist
                pktwert   ffwert    uwert     neuwert   wert
                tmpz      y         tmplist   wdhz      uglist
                plleer    kosys     anzkpn    kplistf   EL_TMP
                )
  (cond
    ((= (cdr (assoc 0 el)) "LINE")
     (setq EL_TMP (nth 1 el))
     (setq el
            (subst
              (cons 11 (cdr (nth 2 el)))
              (nth 1 el)
              el
              ) ;_ end of subst
           ) ;_ end of setq
     (entmod el)
     (setq el
            (subst
              (cons 10 (cdr EL_TMP))
              (nth 2 el)
              el
              ) ;_ end of subst
           ) ;_ end of setq
     (entmod el)
     (setq TEMP el)
     )
    ((= (cdr (assoc 0 el)) "LWPOLYLINE")
     (setq el(vl-remove 'nil
     (mapcar '(lambda(x)
                (if(=(car x)91)
                  NIL
                  x)
                )
             el
             )))
     (setq el (reverse el))
     (setq tmplist (member (assoc 10 el) el))
     (setq tmplist (reverse tmplist))
     (setq tmplist (member (assoc 42 tmplist) tmplist))
     (setq tmplist (reverse tmplist))
     (setq plkpli tmplist)
     (setq lenli (length plkpli))
     (setq wdhz 0)
     (repeat (/ lenli 4)
       (setq zuslist (list
                       (nth (* 4 wdhz) plkpli)
                       (nth (+ 1 (* 4 wdhz)) plkpli)
                       (nth (+ 2 (* 4 wdhz)) plkpli)
                       (nth (+ 3 (* 4 wdhz)) plkpli)
                       ) ;_ end of list
             ) ;_ end of setq
       (setq wdhz (1+ wdhz))
       (if (= uglist nil)
         (setq uglist (list zuslist))
         (setq uglist (append uglist (list zuslist)))
         ) ;_ end of if
       ) ;_ end of repeat
     (foreach elem uglist
       (setq pktwert (assoc 10 elem))
       (setq ffwert (member (assoc 40 elem) elem))
       (if (= ffwertli nil)
         (setq ffwertli (list ffwert))
         (setq ffwertli (append ffwertli (list ffwert)))
         ) ;_ end of if
       (if (= pktwertli nil)
         (setq pktwertli (list pktwert))
         (setq pktwertli (append pktwertli (list pktwert)))
         ) ;_ end of if
       ) ;_ end of foreach
     (setq pktwertli (reverse pktwertli))
     (foreach wert ffwertli
       (setq uwert (nth 2 wert))
       (setq neuwert (cons 42 (* -1 (cdr uwert)))) ;vorher(cadr uwert)
       (setq ffwert (subst neuwert (assoc 42 wert) wert))
       (if (= ffwertlist nil)
         (setq ffwertlist (list ffwert))
         (setq ffwertlist (append ffwertlist (list ffwert)))
         ) ;_ end of if
       ) ;_ end of foreach
     (setq ffwertlist
            (append
              ffwertlist
              (list
                (list (cons 40 0.0) (cons 41 0.0) (cons 42 0.0))
                ) ;_ end of list
              ) ;_ end of append
           ) ;_ end of setq
     (setq ffwertli ffwertlist)
     (setq rdz 0)
     (foreach selpkt pktwertli
       (if (= ugalist nil)
         (setq ugalist (list (append (list selpkt) (nth rdz ffwertli))))
         (setq
           ugalist (append
                     ugalist
                     (list (append (list selpkt) (nth rdz ffwertli)))
                     ) ;_ end of append
           ) ;_ end of setq
         ) ;_ end of if
       (setq rdz (1+ rdz))
       ) ;_ end of foreach
     (setq kpliste ugalist)
     (foreach pkt kpliste
       (if (= kplistf nil)
         (setq kplistf
                (list (car pkt) (cadr pkt) (caddr pkt) (cadddr pkt))
               ) ;_ end of setq
         (setq kplistf (append kplistf
                               (list (car pkt)
                                     (cadr pkt)
                                     (caddr pkt)
                                     (cadddr pkt)
                                     ) ;_ end of list
                               ) ;_ end of append
               ) ;_ end of setq
         ) ;_ end of if
       ) ;_ end of foreach
     (setq plleer el)
     (setq kosys (assoc 210 plleer))
     (setq anzkpn (cons 90 (/ (length kplistf) 4)))
     (setq
       plleer (reverse
                (member (assoc 39 (reverse plleer)) (reverse plleer))
                ) ;_ end of reverse
       ) ;_ end of setq
     (setq nlineli (append plleer kplistf (list kosys)))
     (setq nlineli (subst anzkpn (assoc 90 nlineli) nlineli))
     (setq el (reverse nlineli))
     )
    ) ;_ end of cond
  ) ;_ end of defun


(defun revelem_li (elem / gc10 gc11)
  (setq gc10(assoc 10 elem)
        gc11(assoc 11 elem)
        )
  (setq elem(subst(cons 10(cdr gc11))(assoc 10 elem)elem)
        elem(subst(cons 11(cdr gc10))(assoc 11 elem)elem)
        
        )
  elem
  )





(defun myerror (s)                      ; If an error (such as CTRL-C) occurs
                                        ; while this command is active...
  (if (/= s "Funktion abgebrochen")
    (princ (strcat "\nFehler: " s))
    ) ;_ end of if
  (setvar "cmdecho" CM)                 ; Restore saved modes
  (setq *error* olderr)                 ; Restore old *error* handler
  (princ)
  ) ;_ end of defun

(defun C:DOPPELT (/ CM mit_ins LISTA Lay EARX_LIST NEW aslay ladopp lacount ONE TEMP OLD M:ROTOR wasmach fuzz MD_ZAEHLER ELEM_ZAEHL)

  (setq OLDERR  *ERROR*
        *ERROR* MYERROR
        CM      (getvar "cmdecho")
        mit_ins"N"
        )
  (initget "J N")
(setq mit_ins(getkword"Blockreferenzen bercksichtigen (J/N) <N>: "))
  (if (equal mit_ins "J")
 (setq
        OLD     (ssget "_X"
                       (list '(-4 . "<NOT")
                             '(0 . "VIEWPORT")
                             '(-4 . "NOT>")
                             (cons 410 (getvar "ctab"))
                             ) ;_ end of list
                       ) ;_ end of ssget
        ) ;_ end of setq
    (setq
        OLD     (ssget "_X"
                       (list 
                             '(-4 . "<NOT")
                             '(-4 . "<OR")
                             '(0 . "INSERT")
                             '(0 . "VIEWPORT")
                             '(-4 . "OR>")
                             '(-4 . "NOT>")
                             (cons 410 (getvar "ctab"))
                             ) ;_ end of list
                       ) ;_ end of ssget
        )
    )
  (setvar "cmdecho" 0)
  (initget "S L")
  (setq EARX_LIST(EARX:LIST-LAY))
  (setq wasmach
         (getkword
           "Doppelte Elemente auf <S>eperaten Layer legen oder <L>schen ? <S>"
           ) ;_ end of getkword
        ) ;_ end of setq
  (if
    (null
      (setq
        fuzz (getreal "\nFuzzy Abstand (Nachkommastellen 0-16) <4>: ")
        ) ;_ end of setq
      ) ;_ end of null
     (setq fuzz 4)
     (setq fuzz (fix fuzz))
     ) ;_ end of if
  (command "_-layer" "_u" "*" "")
  (prompt "\Bearbeite Zeichnung ")
  (if (> (sslength OLD) 250)
    (prompt "\nBitte warten... \n")
    ) ;_ end of if
  (cond
    ((= wasmach "L")
     (setq MD_ZAEHLER 0)
     (while
       (> (length EARX_LIST) MD_ZAEHLER)
        (if (setq ASLAY
                   (if (equal mit_ins "J")
                   (ssget "_X"
                          (list '(-4 . "<NOT")
                                '(0 . "VIEWPORT")
                                '(-4 . "NOT>")
                                (cons 8 (nth MD_ZAEHLER EARX_LIST))
                                (cons 410 (getvar "ctab"))
                                ) ;_ end of list
                          ) ;_ end of ssget
                     (ssget "_X"
                          (list '(-4 . "<NOT")
                             '(-4 . "<OR")
                             '(0 . "INSERT")
                             '(0 . "VIEWPORT")
                             '(-4 . "OR>")
                             '(-4 . "NOT>")
                                (cons 8 (nth MD_ZAEHLER EARX_LIST))
                                (cons 410 (getvar "ctab"))
                                ) ;_ end of list
                          )
                     )
                  ) ;_ end of setq
          (progn
            (setq ELEM_ZAEHL 0)
            (while
              (> (sslength ASLAY) ELEM_ZAEHL)
               (setq ONE (ssname ASLAY ELEM_ZAEHL))
               (setq ELEM (append ELEM (list ONE)))
               (setq TEMP (CHECK ONE fuzz))
               (if (or (and (= (DXF 0) "INSERT") (= (DXF 66) 1))
                       (= (DXF 0) "POLYLINE")
                       ) ;_ end of or
                 (COMPLEX one fuzz)
                 ) ;_ end of if
              (if Temp
                (progn
               (cond
                 ((member TEMP LISTA)
                  (foreach X ELEM (entdel x))
                  ) ;_ end of if
                 ((and (/= LISTA nil) (= (cdr (assoc 0 TEMP)) "LINE"))
                  (setq TEMP (revelem TEMP)) ;(revelem TEMP)
                  (if
                    (member TEMP LISTA)
                     (foreach X ELEM (entdel x))
                     ) ;_ end of if
                  )
                 ((and (/= LISTA nil)
                       (= (cdr (assoc 0 TEMP)) "LWPOLYLINE")
                       ) ;_ end of and
                  (setq TEMP (revelem TEMP)) ;(revelem TEMP)
                  (if
                    (member TEMP LISTA)
                     (foreach X ELEM (entdel x))
                     ) ;_ end of if
                  )
                 ) ;_ end of cond
               (setq LISTA (cons TEMP LISTA))
                     )
                )
              (setq ONE   nil
                     TEMP  NIL
                     ELEM  NIL
                     ) ;_ end of setq
               (cond
                 (M:ROTOR (setq M:ROTOR NIL) (princ "\r\\"))
                 (t (setq M:ROTOR (princ "\r/")))
                 ) ;_ end of cond
               (setq ELEM_ZAEHL (1+ ELEM_ZAEHL))
               ) ;_ end of while
            ) ;_ end of progn
          ) ;_ end of if
        (setq LISTA NIL)
        (setq MD_ZAEHLER (1+ MD_ZAEHLER))
        ) ;_ end of while
     (prompt
       (strcat "\nEs wurden "
               (itoa (- (sslength OLD)
                        (sslength(if (equal mit_ins "J")
                          (ssget "_X"
                                         (list '(-4 . "<NOT")
                                               '(0 . "VIEWPORT")
                                               '(-4 . "NOT>")
                                               (cons 410 (getvar "ctab"))
                                               ) ;_ end of list
                                         ) ;_ end of ssget
                          (ssget "_X"
                       (list 
                             '(-4 . "<NOT")
                             '(-4 . "<OR")
                             '(0 . "INSERT")
                             '(0 . "VIEWPORT")
                             '(-4 . "OR>")
                             '(-4 . "NOT>")
                             (cons 410 (getvar "ctab"))
                             ) ;_ end of list
                       )
                                   )
                                  ) ;_ end of sslength
                        ) ;_ end of -
                     ) ;_ end of itoa
               " Elemente gelscht!"
               ) ;_ end of strcat
       ) ;_ end of prompt
     )


    ((or (null wasmach) (= wasmach "S"))
     (setq MD_ZAEHLER 0)
     (setq oldlay (getvar "clayer"))
     (if (not (tblsearch "layer" "doppelt"))
       (progn
         (setq ladopp "doppelt")
         (command "_.Layer" "_m" "doppelt" "") ;_ end of command
         ) ;_ end of progn
       (Progn
         (setq ladopp "doppelt_000")
         (command "_.Layer" "_m" "doppelt_000" "") ;_ end of command
         ) ;_ end of Progn
       ) ;_ end of if
     (while
       (> (length EARX_LIST) MD_ZAEHLER)
        (if (setq ASLAY
                   (if (equal mit_ins "J")
                   (ssget "_X"
                          (list '(-4 . "<NOT")
                                '(0 . "VIEWPORT")
                                '(-4 . "NOT>")
                                (cons 8 (nth MD_ZAEHLER EARX_LIST))
                                (cons 410 (getvar "ctab"))
                                ) ;_ end of list
                          ) ;_ end of ssget
                     (ssget "_X"
                          (list '(-4 . "<NOT")
                             '(-4 . "<OR")
                             '(0 . "INSERT")
                             '(0 . "VIEWPORT")
                             '(-4 . "OR>")
                             '(-4 . "NOT>")
                                (cons 8 (nth MD_ZAEHLER EARX_LIST))
                                (cons 410 (getvar "ctab"))
                                ) ;_ end of list
                          )
                     )
                  ) ;_ end of setq
          (progn
            (setq ELEM_ZAEHL 0)
            (while
              (> (sslength ASLAY) ELEM_ZAEHL)
               (setq ONE (ssname ASLAY ELEM_ZAEHL))
               (setq ELEM (append ELEM (list ONE)))
               (setq TEMP (CHECK ONE fuzz))
               (if (or (and (= (DXF 0) "INSERT") (= (DXF 66) 1))
                       (= (DXF 0) "POLYLINE")
                       ) ;_ end of or
                 (COMPLEX one fuzz)
                 ) ;_ end of if
               (cond
                 ((member TEMP LISTA)
                  (foreach X ELEM
                    (entmod
                      (subst (cons 8 ladopp)
                             (assoc 8 (entget x))
                             (entget x)
                             ) ;_ end of subst
                      ) ;_ end of entmod
                    ) ;_ end of foreach
                  )
                 ((and (/= LISTA nil) (= (cdr (assoc 0 TEMP)) "LINE"))
                  (setq TEMP (revelem TEMP)) ;(revelem TEMP)
                  (if
                    (member TEMP LISTA)
                     (foreach X ELEM
                       (entmod
                         (subst (cons 8 ladopp)
                                (assoc 8 (entget x))
                                (entget x)
                                ) ;_ end of subst
                         ) ;_ end of entmod
                       ) ;_ end of foreach
                     ) ;_ end of if
                  )
                 ((and (/= LISTA nil)
                       (= (cdr (assoc 0 TEMP)) "LWPOLYLINE")
                       ) ;_ end of and
                  (setq TEMP (revelem TEMP))
                  (if
                    (member TEMP LISTA)
                     (foreach X ELEM
                       (entmod
                         (subst (cons 8 ladopp)
                                (assoc 8 (entget x))
                                (entget x)
                                ) ;_ end of subst
                         ) ;_ end of entmod
                       ) ;_ end of foreach
                     ) ;_ end of if
                  )
                 ) ;_ end of cond
               (if Temp(setq LISTA (cons TEMP LISTA)))
                    (setq TEMP  NIL
                     ELEM  NIL
                     ) ;_ end of setq
               (cond
                 (M:ROTOR (setq M:ROTOR NIL) (princ "\r\\"))
                 (t (setq M:ROTOR (princ "\r/")))
                 ) ;_ end of cond
               (setq ELEM_ZAEHL (1+ ELEM_ZAEHL))
               ) ;_ end of while
            ) ;_ end of progn
          ) ;_ end of if
        (setq LISTA NIL)
        (setq MD_ZAEHLER (1+ MD_ZAEHLER))
        ) ;_ end of while
     (if (ssget
           "_X"
           (list '(-4 . "<NOT")
                 '(0 . "VIEWPORT")
                 '(-4 . "NOT>")
                 (cons 8 ladopp)
                 (cons 410 (getvar "ctab"))
                 ) ;_ end of list
           ) ;_ end of ssget
       (progn
       (prompt
         (strcat
           "\nEs wurden "
           (itoa
             ;(- (sslength OLD)
                    (sslength (ssget "_X"
                                     (list '(-4 . "<NOT")
                                           '(0 . "VIEWPORT")
                                           '(-4 . "NOT>")
                                           (cons 8 ladopp)
                                           (cons 410 (getvar "ctab"))
                                           ) ;_ end of list
                                     ) ;_ end of ssget
                              ) 
                 ) ;_ end of itoa
           " Elemente gendert!"
           ) ;_ end of strcat
         ) ;_ end of prompt
       (if
         (setq ELEM_ZAEHL (ssget "_X" (list  '(0 . "INSERT")
                                           (cons 8 ladopp)
                                           (cons 410 (getvar "ctab"))
                                           ) ;_ end of list
                                     )
               )
         (prompt(strcat"\nAchtung! "(itoa(sslength ELEM_ZAEHL)) " Objekte sind Blockreferenzen, die lediglich alle den gleichen Einfgepunkt haben. Diese Objekte mssen nicht deckungsgleich bereinander liegen!"))
       ))
       (progn
         (setvar "clayer" oldlay)
         (command "_.purge" "_la" ladopp "n")
         (prompt
           (strcat "\nEs wurden keine Doppelten Elemente gefunden!"
                   ) ;_ end of strcat
           ) ;_ end of prompt
         ) ;_ end of progn
       ) ;_ end of if
     )
    ) ;_ end of cond
  (setvar "cmdecho" CM)
  (princ)
  ) ;_ end of defun
(prompt "\nStarten mit DOPPELT.\n")
(princ)
